<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995-7 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>Assignment #2 Answers</title>
</head>
<body>
<H1>Assignment #2 Answers</H1>





<B>Introductory C Programming
<br>
<br>
UW Experimental College
<br>
<br>
Assignment #2 ANSWERS
</B><br>
<br>
<p>Question 1.
<I>What are the two different kinds of division
that the <TT>/</TT> operator can do?
Under what circumstances does it perform each?
</I><p>The two kinds of division are integer division,
which discards any remainder,
and floating-point division,
which yields a floating-point result
(with a fractional part, if necessary).
Floating-point division is performed
if either operand
(or both)
is floating-point
(that is, if either number being operated on is floating-point);
integer division is performed if both operands are integers.
<p>Question 2.
<I>What are the definitions of the ``Boolean'' values
true and false in C?
</I><p>False is always represented by a zero value.
Any nonzero value is considered true.
The built-in operators
<TT>&lt;</TT>, <TT>&lt;=</TT>, <TT>&gt;</TT>, <TT>&gt;=</TT>, <TT>==</TT>, <TT>!=</TT>, 
<TT>&amp;&amp;</TT>, <TT>||</TT>, and <TT>!</TT>
always generate 0 for false and 1 for true.
<p>Question 3.
<I>Name three uses for the semicolon in C.
</I><p>Terminating declarations,
terminating statements,
and
separating the three control expressions in a <TT>for</TT> loop.
<p>Question 4.
<I>What would the equivalent code, using a while loop, be for the example
</I><pre>
	for(i = 0; i &lt; 10; i = i + 1)
		printf("i is %d\n", i);
</pre>
<I></I>?
<p>Just move the first (initialization) expression to before the loop,
and the third (increment) expression to the body of the loop:
<pre>
	i = 0;
	while(i &lt; 10)
		{
		printf("i is %d\n", i);
		i = i + 1;
		}
</pre>
<p>Question 5.
<I>What is the numeric value of the expression <TT>3 &lt; 4</TT> ?
</I><p>1 (or ``true''),
because 3 is in fact less than 4.
<p>Question 6.
<I>Under what conditions will this code print ``water''?
</I><pre>
	if(T &lt; 32)
		printf("ice\n");
	else if(T &lt; 212)
		printf("water\n");
	else	printf("steam\n");
</pre>
<p>If <TT>T</TT> is greater than or equal to 32 <em>and</em> less than 212.
(If you said ``greater than 32 and less than 212'',
you weren't quite right,
and this kind of distinction--paying
attention to the difference between
``greater than'' and ``greater than or equal''--is
often extremely important in programming.)
<p>Question 7.
<I>What would this code print?
</I><pre>
	int x = 3;
	if(x)
		printf("yes\n");
	else	printf("no\n");
</pre>
<p>It would print ``yes'', since <TT>x</TT> is nonzero.
<p>Question 8.
<I>What would this code print?
</I><pre>
	int i;

	for(i = 0; i &lt; 3; i = i + 1)
		printf("a\n");
		printf("b\n");
	printf("c\n");
</pre>
<p>It would print
<pre>
	a
	a
	a
	b
	c
</pre>
The indentation of the statement <TT>printf("b\n");</TT> is
(deliberately, for the sake of the question)
misleading.
It <em>looks</em> like it's part of the body of the <TT>for</TT> statement,
but the body of the <TT>for</TT> statement is always a single statement,
or a list of statements enclosed in braces {}.
In this case, the body of the loop is the call
<TT>printf("a\n");</TT>.
The two statements
<TT>printf("b\n");</TT> and <TT>printf("c\n");</TT>
are normal statements following the loop.
<p>The code would be <em>much</em> clearer if the
<TT>printf("b\n");
</TT>line were indented to line up with the
<TT>printf("c\n");
</TT>line.
If the intent was that ``b'' be printed 3 times, along 
with ``a'', it would be necessary to put braces 
<TT>{}</TT> around the pair of lines
<TT>printf("a\n");
</TT>and
<TT>printf("b\n");
</TT>.
<p>Exercise 1.
<I>Write a program to find out
how many of the numbers from 1 to 10 are greater than 3.
</I><p><pre>
#include &lt;stdio.h&gt;

int main()
{
int i;
int count = 0;

for(i = 1; i &lt;= 10; i = i + 1)
	{
	if(i &gt; 3)
		count = count + 1;
	}

printf("%d numbers were greater than 3\n", count);

return 0;
}
</pre>
<p>Tutorial 4b.
<I>Print ``On the first day'' instead of
``On the 1 day'' in the days-of-Christmas program.
</I><p>Simply replace the lines
<pre>
		printf("On the %d day of Christmas, ", day);
		printf("my true love gave to me\n");
</pre>
with
<pre>
		printf("On the ");
		if(day == 1) printf("first");
		else if(day == 2) printf("second");
		else if(day == 3) printf("third");
		else if(day == 4) printf("fourth");
		else if(day == 5) printf("fifth");
		else if(day == 6) printf("sixth");
		else	printf("%d", day);
		printf(" day of Christmas, ");
		printf("my true love gave to me\n");
</pre>
The final
<pre>
		else printf("%d", day);
</pre>
is an example of ``defensive programming.''
If the variable <TT>day</TT> ever ends up having a value
outside the range 1-6
(perhaps because we later added more verses to the song,
but forgot to update the list of words),
the program will at least print something.

<p>Exercise 2.
<I>Write a program to compute the average of the ten numbers
1, 4, 9, ..., 81, 100.
</I><p><pre>
#include &lt;stdio.h&gt;

int main()
{
int i;
float sum = 0;
int n = 0;

for(i = 1; i &lt;= 10; i = i + 1)
	{
	sum = sum + i * i;
	n = n + 1;
	}

printf("the average is %f\n", sum / n);

return 0;
}
</pre>
<p>Exercise 3.
<I>Write a program to print the numbers between 1 and 10,
along with an indication of whether each is even or odd.
</I><p><pre>
#include &lt;stdio.h&gt;

int main()
{
	int i;

	for(i = 1; i &lt;= 10; i = i + 1)
		{
		if(i % 2 == 0)
			printf("%d is even\n", i);
		else	printf("%d is odd\n", i);
		}

	return 0;
}
</pre>
<p>Exercise 4.
<I>Print out the 8 points of the compass,
based on the <TT>x</TT> and <TT>y</TT> components of the direction of travel.
</I><p><pre>
if(x &gt; 0)
	{
	if(y &gt; 0)
		printf("Northeast.\n");
	else if(y &lt; 0)
		printf("Southeast.\n");
	else	printf("East.\n");
	}
else if(x &lt; 0)
	{
	if(y &gt; 0)
		printf("Northwest.\n");
	else if(y &lt; 0)
		printf("Southwest.\n");
	else	printf("West.\n");
	}
else	{
	if(y &gt; 0)
		printf("North.\n");
	else if(y &lt; 0)
		printf("South.\n");
	else	printf("Nowhere.\n");
	}
</pre>
(You will notice that this code also prints 
``Nowhere'' in the ninth case,
namely when <TT>x == 0</TT> and <TT>y == 0</TT>.)
<p>Exercise 5.
<I>Write a program to print the first 7 positive integers
and their factorials.
</I><p><pre>
#include &lt;stdio.h&gt;

int main()
{
	int i;
	int factorial = 1;

	for(i = 1; i &lt;= 7; i = i + 1)
		{
		factorial = factorial * i;
		printf("%d   %d\n", i, factorial);
		}

	return 0;
}
</pre>
<p>The answer to the extra credit question is that 8!,
which is how mathematicians write ``eight factorial,''
is 40320,
which is <em>not</em> guaranteed to fit into a variable of type <TT>int</TT>.
To write a portable program to compute factorials higher than 7,
we would have to use <TT>long int</TT>.
<p>Exercise 6.
<I>Write a program to print the first 10 Fibonacci numbers.
</I><p><pre>
#include &lt;stdio.h&gt;

int main()
{
	int i;
	int fibonacci = 1;
	int prevfib = 0;
	int tmp;

	for(i = 1; i &lt;= 10; i = i + 1)
		{
		printf("%d   %d\n", i, fibonacci);
		tmp = fibonacci;
		fibonacci = fibonacci + prevfib;
		prevfib = tmp;
		}

	return 0;
}
</pre>
(There are many ways of writing this program.
As long as the code you wrote printed
1, 1, 2, 3, 5, 8, 13, 21, 34, 55,
it's probably correct.
If the code you wrote is clearer than my solution above,
so much the
better!)
<p>Exercise 7.
<I>Make some improvements to the prime number printing program.
</I><p>Here is a version incorporating both of the suggested improvements:
<pre>
#include &lt;stdio.h&gt;
#include &lt;math.h&gt;

int main()
{
int i, j;
double sqrti;

printf("%d\n", 2);

for(i = 3; i &lt;= 100; i = i + 2)
	{
	sqrti = sqrt(i);
	for(j = 2; j &lt; i; j = j + 1)
		{
		if(i % j == 0)
			break;			/* not prime */
		if(j &gt; sqrti)
			{			/* prime */
			printf("%d\n", i);
			break;
			}
		}
	}

return 0;
}
</pre>
<hr>
<hr>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995-9
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
